#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cachetest.h"

//#define X_FIRST
//#define DEBUG
//#define TEST
#define INLINE_OPT

#define SIZE 10000


#ifndef INLINE_OPT
int inc_mat_opt(int *m, int x_size, int y_size) {
#else
int inc_mat_opt(int *m, int xs, int ys) {
#define x_size SIZE
#define y_size SIZE
#endif
	
  register int l;
  register int sum = 0;
  register int *m1 = m;
  register int *mat;

#ifdef X_FIRST
  for ( l = 0; l < y_size; l++, m1+=x_size) {
    mat = m1 + x_size-1;
    for ( ; mat >= m1; mat--) {
      (*mat)++;
      //sum += (*mat);
    }
  }
#else
  for ( l = 0; l < x_size; l++, m1++) {
    mat = m1 + (x_size*y_size)-x_size;
    for ( ;mat >= m1; mat -= x_size) {
      (*mat)++;
      //sum += (*mat);
    }
  }
#endif

  return sum;
}

#ifndef INLINE_OPT
int inc_mat(int *mat, int x_size, int y_size) {
#else
int inc_mat(int *mat, int xs, int ys) {
#define x_size SIZE
#define y_size SIZE
#endif
	
  register int x, y, x_index, y_index;

#ifdef X_FIRST
  for ( y = 0 , y_index = 0; y < y_size; y++, y_index += x_size) {
		x_index = y_index;
    for ( x = 0; x < x_size; x++) {
      mat[x_index++]++;
#ifdef DEBUG 
			printf("Index: %d (%d,%d) (%d,%d) -> %d\n",x_index,x,y,x_size,y_size,mat[x_index] );
#endif
    }
  }
#else
  for ( x = 0, x_index = 0 ; x < x_size; x++, x_index++) {
    for ( y = 0, y_index = x_index; y < y_size; y++, y_index += x_size) {
      mat[y_index]++;
#ifdef DEBUG 
			printf("Index: %d (%d,%d) (%d,%d) -> %d\n",y_index,x,y,x_size,y_size,mat[y_index] );
#endif
    }
  }
#endif
  return 0;
}


int run_mat_test() {
#ifdef TEST
  int i;
#endif
  int *mat = (int*)malloc(SIZE*SIZE*sizeof(int));
#ifdef TEST
  memset(mat, 0, SIZE*SIZE*sizeof(int));
#endif
  inc_mat_opt(mat, SIZE, SIZE);

#ifdef TEST
  for ( i = 0; i < SIZE*SIZE; i++) {
    if (mat[i] != 1) {
			printf("Error : %d\n",mat[i]);
	  }
	}
	printf("Test done!\n");
#endif
  free(mat);
  
  return 0;
}
